package scheme.absyn;

import scheme.interp.VisitE;

public class Prim {
    public static final byte MINUS = 0;
    public static final byte TIMES = 1;
    public static final byte PLUS = 2;
    public static final byte LESS = 3;
    public static final byte LEQ = 4;
    public static final byte EQ = 5;
    public static final byte ADD1 = 6;
    public static final byte BOOLEANP = 7;
    public static final byte CAR = 8;
    public static final byte CDR = 9;
    public static final byte CONS = 10;
    public static final byte INTEGERP = 11;
    public static final byte NOT = 12;
    public static final byte NULLP = 13;
    public static final byte PAIRP = 14;
    public static final byte PROCEDUREP = 15;
    public static final byte SUB1 = 16;
    public static final byte VOID = 17;
    public static final byte ZEROP = 18;
    public static final byte EQP = 19;
    public static final byte SETCAR = 20;
    public static final byte SETCDR = 21;

    public static int opArity (byte op) throws VisitE { 

        switch (op) {

        case MINUS:
        case TIMES: 
        case PLUS: return 2;

        case LESS:
        case LEQ:
        case EQ: 
        case EQP: return 2;

        case CONS: 
        case SETCAR: 
        case SETCDR: return 2;

        case CAR: 
        case CDR: return 1;

        case ADD1: 
        case SUB1: 
        case NOT: return 1;

        case BOOLEANP:
        case INTEGERP:
        case NULLP:
        case PAIRP:
        case PROCEDUREP:
        case ZEROP: return 1;

        case VOID: return 0;
            
        default: throw new VisitE("Unknown operator");
        }

    }

    public static String opName (byte op) throws VisitE {
        switch (op) {
        case MINUS: return "-";
        case TIMES: return "*";
        case PLUS: return "+";
        case LESS: return "<";
        case LEQ: return "<=";
        case EQ: return "=";
        case EQP: return "eq?";
        case CONS: return "cons";
        case SETCAR: return "set-car!";
        case SETCDR: return "set-cdr!";
        case CAR: return "car";
        case CDR: return "cdr";
        case ADD1: return "add1";
        case SUB1: return "sub1";
        case NOT: return "not";
        case BOOLEANP: return "boolean?";
        case INTEGERP: return "integer?";
        case NULLP: return "null?";
        case PAIRP: return "pair?";
        case PROCEDUREP: return "procedure?";
        case ZEROP: return "zero?";
        case VOID: return "void";
        default: throw new VisitE("Unknown operator");
        }
    }
}
