package scheme.interp;

import scheme.util.List;
import scheme.util.EmptyL;
import scheme.absyn.Exp;

public class ClosureV extends SchemeValue {
    private List ids;
    private Exp body;
    private Env env;

    public ClosureV (List ids, Exp body, Env env) { 
        this.ids = ids;
        this.body = body;
        this.env = env; 
    }

	// changed to use Store and Environment
    public SchemeValue apply (List argVs, Eval_Exp eval_exp) throws VisitE {
        Store s = eval_exp.getStore();
        Env saved_env = eval_exp.getEnv(), newenv = env;
        List xs = ids;
        int location;
        
        while (!(xs instanceof EmptyL)) {
            location = s.alloc((SchemeValue)argVs.hd());
            
            newenv = newenv.add((String)xs.hd(), new Integer(location));
            
            xs = xs.tl();
            argVs = argVs.tl();
        }
        
        eval_exp.setEnv(newenv);
        body.accept(eval_exp);
        eval_exp.setEnv(saved_env);
        
        return eval_exp.getValue();
    }

    public String toString () {
        return "<procedure>";
    }
}
