// $ANTLR 2.7.1: "scheme.g" -> "SchemeTreeParser.java"$

package scheme.parser;
import scheme.absyn.*;
import scheme.util.*;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


public class SchemeTreeParser extends antlr.TreeParser
       implements SchemeTokenTypes
 {
public SchemeTreeParser() {
	tokenNames = _tokenNames;
}

	public final Exp  exp(AST _t) throws RecognitionException {
		Exp e;
		
		AST exp_AST_in = (AST)_t;
		AST i = null;
		AST si = null;
		
		e = null;
		byte primop;
		ExpList exps = new EmptyExpL();
		List decls = new EmptyL();
		Exp se, e1, e2, e3, be, letb, letrecb, lamb, pa, fun, arg;
		Const c;
		Datum d, qd;
		Decl letd, letrecd;
		List ps = new EmptyL();
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case TRUE:
			case FALSE:
			case INT:
			{
				c=constant(_t);
				_t = _retTree;
				e = new ConstantE (c);
				break;
			}
			case ID:
			{
				i = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				e = new VarE(i.getText());
				break;
			}
			case LITERAL_quote:
			{
				AST __t47 = _t;
				AST tmp65_AST_in = (AST)_t;
				match(_t,LITERAL_quote);
				_t = _t.getFirstChild();
				d=datum(_t);
				_t = _retTree;
				_t = __t47;
				_t = _t.getNextSibling();
				e = new QuoteE (d);
				break;
			}
			case QUOTECHAR:
			{
				AST __t48 = _t;
				AST tmp66_AST_in = (AST)_t;
				match(_t,QUOTECHAR);
				_t = _t.getFirstChild();
				qd=datum(_t);
				_t = _retTree;
				_t = __t48;
				_t = _t.getNextSibling();
				e = new QuoteE (qd);
				break;
			}
			case 26:
			{
				AST __t49 = _t;
				AST tmp67_AST_in = (AST)_t;
				match(_t,26);
				_t = _t.getFirstChild();
				si = (AST)_t;
				match(_t,ID);
				_t = _t.getNextSibling();
				se=exp(_t);
				_t = _retTree;
				_t = __t49;
				_t = _t.getNextSibling();
				e = new SetE(si.getText(),se);
				break;
			}
			case LITERAL_if:
			{
				AST __t50 = _t;
				AST tmp68_AST_in = (AST)_t;
				match(_t,LITERAL_if);
				_t = _t.getFirstChild();
				e1=exp(_t);
				_t = _retTree;
				e2=exp(_t);
				_t = _retTree;
				e3=exp(_t);
				_t = _retTree;
				_t = __t50;
				_t = _t.getNextSibling();
				e = new IfE(e1,e2,e3);
				break;
			}
			case LITERAL_begin:
			{
				AST __t51 = _t;
				AST tmp69_AST_in = (AST)_t;
				match(_t,LITERAL_begin);
				_t = _t.getFirstChild();
				{
				_loop53:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_0.member(_t.getType()))) {
						be=exp(_t);
						_t = _retTree;
						exps = exps.snoc(be);
					}
					else {
						break _loop53;
					}
					
				} while (true);
				}
				_t = __t51;
				_t = _t.getNextSibling();
				e = new BeginE (exps);
				break;
			}
			case LITERAL_let:
			{
				AST __t54 = _t;
				AST tmp70_AST_in = (AST)_t;
				match(_t,LITERAL_let);
				_t = _t.getFirstChild();
				{
				_loop56:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==DECL)) {
						letd=decl(_t);
						_t = _retTree;
						decls = decls.snoc(letd);
					}
					else {
						break _loop56;
					}
					
				} while (true);
				}
				letb=exp(_t);
				_t = _retTree;
				_t = __t54;
				_t = _t.getNextSibling();
				e = new LetE(decls,letb);
				break;
			}
			case LITERAL_letrec:
			{
				AST __t57 = _t;
				AST tmp71_AST_in = (AST)_t;
				match(_t,LITERAL_letrec);
				_t = _t.getFirstChild();
				{
				_loop59:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_t.getType()==DECL)) {
						letrecd=decl(_t);
						_t = _retTree;
						decls = decls.snoc(letrecd);
					}
					else {
						break _loop59;
					}
					
				} while (true);
				}
				letrecb=exp(_t);
				_t = _retTree;
				_t = __t57;
				_t = _t.getNextSibling();
				e = new LetrecE(decls,letrecb);
				break;
			}
			case LITERAL_lambda:
			{
				AST __t60 = _t;
				AST tmp72_AST_in = (AST)_t;
				match(_t,LITERAL_lambda);
				_t = _t.getFirstChild();
				ps=params(_t);
				_t = _retTree;
				lamb=exp(_t);
				_t = _retTree;
				_t = __t60;
				_t = _t.getNextSibling();
				e = new LambdaE(ps,lamb);
				break;
			}
			case PRIM:
			{
				AST __t61 = _t;
				AST tmp73_AST_in = (AST)_t;
				match(_t,PRIM);
				_t = _t.getFirstChild();
				primop=prim(_t);
				_t = _retTree;
				{
				_loop63:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_0.member(_t.getType()))) {
						pa=exp(_t);
						_t = _retTree;
						exps = exps.snoc(pa);
					}
					else {
						break _loop63;
					}
					
				} while (true);
				}
				_t = __t61;
				_t = _t.getNextSibling();
				e = new PrimappE (primop,exps);
				break;
			}
			case APP:
			{
				AST __t64 = _t;
				AST tmp74_AST_in = (AST)_t;
				match(_t,APP);
				_t = _t.getFirstChild();
				fun=exp(_t);
				_t = _retTree;
				{
				_loop66:
				do {
					if (_t==null) _t=ASTNULL;
					if ((_tokenSet_0.member(_t.getType()))) {
						arg=exp(_t);
						_t = _retTree;
						exps = exps.snoc(arg);
					}
					else {
						break _loop66;
					}
					
				} while (true);
				}
				_t = __t64;
				_t = _t.getNextSibling();
				e = new AppE (fun,exps);
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return e;
	}
	
	public final Const  constant(AST _t) throws RecognitionException {
		Const c;
		
		AST constant_AST_in = (AST)_t;
		AST i = null;
		
		c = null;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case TRUE:
			{
				AST tmp75_AST_in = (AST)_t;
				match(_t,TRUE);
				_t = _t.getNextSibling();
				c = new BoolC(true);
				break;
			}
			case FALSE:
			{
				AST tmp76_AST_in = (AST)_t;
				match(_t,FALSE);
				_t = _t.getNextSibling();
				c = new BoolC(false);
				break;
			}
			case INT:
			{
				i = (AST)_t;
				match(_t,INT);
				_t = _t.getNextSibling();
				c = new IntC(Integer.parseInt(i.getText()));
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return c;
	}
	
	public final Datum  datum(AST _t) throws RecognitionException {
		Datum datum;
		
		AST datum_AST_in = (AST)_t;
		
		datum = null;
		Const c;
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case TRUE:
			case FALSE:
			case INT:
			{
				c=constant(_t);
				_t = _retTree;
				datum = new ConstantD (c);
				break;
			}
			case EMPTY_LIST:
			{
				AST tmp77_AST_in = (AST)_t;
				match(_t,EMPTY_LIST);
				_t = _t.getNextSibling();
				datum = new EmptyListD();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return datum;
	}
	
	public final Decl  decl(AST _t) throws RecognitionException {
		Decl decl;
		
		AST decl_AST_in = (AST)_t;
		AST i = null;
		
		decl = null;
		Exp rhs;
		
		
		try {      // for error handling
			AST __t74 = _t;
			AST tmp78_AST_in = (AST)_t;
			match(_t,DECL);
			_t = _t.getFirstChild();
			i = (AST)_t;
			match(_t,ID);
			_t = _t.getNextSibling();
			rhs=exp(_t);
			_t = _retTree;
			_t = __t74;
			_t = _t.getNextSibling();
			decl = new Decl(i.getText(),rhs);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return decl;
	}
	
	public final List  params(AST _t) throws RecognitionException {
		List ids;
		
		AST params_AST_in = (AST)_t;
		AST id = null;
		
		ids = new EmptyL();
		
		
		try {      // for error handling
			AST __t68 = _t;
			AST tmp79_AST_in = (AST)_t;
			match(_t,PARAMS);
			_t = _t.getFirstChild();
			{
			_loop70:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==ID)) {
					id = (AST)_t;
					match(_t,ID);
					_t = _t.getNextSibling();
					ids = ids.snoc(id.getText());
				}
				else {
					break _loop70;
				}
				
			} while (true);
			}
			_t = __t68;
			_t = _t.getNextSibling();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return ids;
	}
	
	public final byte  prim(AST _t) throws RecognitionException {
		byte primb;
		
		AST prim_AST_in = (AST)_t;
		
		primb = (byte)(-1);
		
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case MINUS:
			{
				AST tmp80_AST_in = (AST)_t;
				match(_t,MINUS);
				_t = _t.getNextSibling();
				primb = Prim.MINUS;
				break;
			}
			case TIMES:
			{
				AST tmp81_AST_in = (AST)_t;
				match(_t,TIMES);
				_t = _t.getNextSibling();
				primb = Prim.TIMES;
				break;
			}
			case PLUS:
			{
				AST tmp82_AST_in = (AST)_t;
				match(_t,PLUS);
				_t = _t.getNextSibling();
				primb = Prim.PLUS;
				break;
			}
			case LESS:
			{
				AST tmp83_AST_in = (AST)_t;
				match(_t,LESS);
				_t = _t.getNextSibling();
				primb = Prim.LESS;
				break;
			}
			case LEQ:
			{
				AST tmp84_AST_in = (AST)_t;
				match(_t,LEQ);
				_t = _t.getNextSibling();
				primb = Prim.LEQ;
				break;
			}
			case EQ:
			{
				AST tmp85_AST_in = (AST)_t;
				match(_t,EQ);
				_t = _t.getNextSibling();
				primb = Prim.EQ;
				break;
			}
			case 32:
			{
				AST tmp86_AST_in = (AST)_t;
				match(_t,32);
				_t = _t.getNextSibling();
				primb = Prim.ADD1;
				break;
			}
			case 33:
			{
				AST tmp87_AST_in = (AST)_t;
				match(_t,33);
				_t = _t.getNextSibling();
				primb = Prim.BOOLEANP;
				break;
			}
			case LITERAL_car:
			{
				AST tmp88_AST_in = (AST)_t;
				match(_t,LITERAL_car);
				_t = _t.getNextSibling();
				primb = Prim.CAR;
				break;
			}
			case LITERAL_cdr:
			{
				AST tmp89_AST_in = (AST)_t;
				match(_t,LITERAL_cdr);
				_t = _t.getNextSibling();
				primb = Prim.CDR;
				break;
			}
			case LITERAL_cons:
			{
				AST tmp90_AST_in = (AST)_t;
				match(_t,LITERAL_cons);
				_t = _t.getNextSibling();
				primb = Prim.CONS;
				break;
			}
			case 37:
			{
				AST tmp91_AST_in = (AST)_t;
				match(_t,37);
				_t = _t.getNextSibling();
				primb = Prim.INTEGERP;
				break;
			}
			case LITERAL_not:
			{
				AST tmp92_AST_in = (AST)_t;
				match(_t,LITERAL_not);
				_t = _t.getNextSibling();
				primb = Prim.NOT;
				break;
			}
			case 39:
			{
				AST tmp93_AST_in = (AST)_t;
				match(_t,39);
				_t = _t.getNextSibling();
				primb = Prim.NULLP;
				break;
			}
			case 40:
			{
				AST tmp94_AST_in = (AST)_t;
				match(_t,40);
				_t = _t.getNextSibling();
				primb = Prim.PAIRP;
				break;
			}
			case 41:
			{
				AST tmp95_AST_in = (AST)_t;
				match(_t,41);
				_t = _t.getNextSibling();
				primb = Prim.PROCEDUREP;
				break;
			}
			case 42:
			{
				AST tmp96_AST_in = (AST)_t;
				match(_t,42);
				_t = _t.getNextSibling();
				primb = Prim.SUB1;
				break;
			}
			case LITERAL_void:
			{
				AST tmp97_AST_in = (AST)_t;
				match(_t,LITERAL_void);
				_t = _t.getNextSibling();
				primb = Prim.VOID;
				break;
			}
			case 44:
			{
				AST tmp98_AST_in = (AST)_t;
				match(_t,44);
				_t = _t.getNextSibling();
				primb = Prim.ZEROP;
				break;
			}
			case 45:
			{
				AST tmp99_AST_in = (AST)_t;
				match(_t,45);
				_t = _t.getNextSibling();
				primb = Prim.EQP;
				break;
			}
			case 46:
			{
				AST tmp100_AST_in = (AST)_t;
				match(_t,46);
				_t = _t.getNextSibling();
				primb = Prim.SETCAR;
				break;
			}
			case 47:
			{
				AST tmp101_AST_in = (AST)_t;
				match(_t,47);
				_t = _t.getNextSibling();
				primb = Prim.SETCDR;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			if (_t!=null) {_t = _t.getNextSibling();}
		}
		_retTree = _t;
		return primb;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"TRUE",
		"FALSE",
		"LEQ",
		"QUOTECHAR",
		"LPAREN",
		"RPAREN",
		"MINUS",
		"DOT",
		"TIMES",
		"PLUS",
		"LESS",
		"EQ",
		"ID",
		"INT",
		"WS",
		"COMMENT",
		"APP",
		"PRIM",
		"EMPTY_LIST",
		"DECL",
		"PARAMS",
		"\"quote\"",
		"\"set!\"",
		"\"if\"",
		"\"begin\"",
		"\"let\"",
		"\"letrec\"",
		"\"lambda\"",
		"\"add1\"",
		"\"boolean?\"",
		"\"car\"",
		"\"cdr\"",
		"\"cons\"",
		"\"integer?\"",
		"\"not\"",
		"\"null?\"",
		"\"pair?\"",
		"\"procedure?\"",
		"\"sub1\"",
		"\"void\"",
		"\"zero?\"",
		"\"eq?\"",
		"\"set-car!\"",
		"\"set-cdr!\""
	};
	
	private static final long _tokenSet_0_data_[] = { 4264755376L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	}
	
